# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without repolib
%global namedversion %{version}

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           testng
Version:        6.3.1
Release:	2%{?dist}
Epoch:          0
Summary:        TestNG
License:        ASL 2.0
Group:          Development/Testing
URL:            http://testng.org
# git clone https://github.com/cbeust/testng.git && cd testng && git archive --prefix="testng-6.3.1/" --format=tar testng-6.3.1 | bzip2 > ../testng-6.3.1.tar.bz2
Source0:        testng-6.3.1.tar.bz2
Patch0:         testng-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java
BuildRequires:  java-devel
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
# XXX: 2.0b4
Requires:       bsh2 >= 0:2.0
Requires:       jcommander >= 0:1.12
Requires:       junit >= 0:3.8.1
Requires:       snakeyaml >= 0:1.6
BuildRequires:  maven-skins
BuildRequires:  oss-parent >= 0:3
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  jcommander >= 0:1.12
BuildRequires:  google-guice >= 0:2.0
BuildRequires:  junit >= 0:3.8.1
# XXX: 2.0b4
BuildRequires:  bsh2 >= 0:2.0
BuildRequires:  snakeyaml >= 0:1.6
# XXX: 2.1.0
BuildRequires:  maven-plugin-bundle
# XXX: 2.3.1
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-gpg
# XXX: 2.3.1
BuildRequires:  maven2-plugin-jar
# XXX: 2.7
BuildRequires:  maven2-plugin-javadoc
# XXX: 2.4.1
BuildRequires:  maven2-plugin-resources
# XXX: 2.1.1
BuildRequires:  maven2-plugin-source
# XXX: 2.5
BuildRequires:  maven2-plugin-surefire
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
TestNG is a testing framework inspired from JUnit and NUnit
but introducing some new functionalities that make it more 
powerful and easier to use, such as:
- JDK 5 Annotations (JDK 1.4 is also supported with JavaDoc 
  annotations). 
- Flexible test configuration. 
- Support for data-driven testing (with @DataProvider). 
- Support for parameters. 
- Allows distribution of tests on slave machines. 
- Powerful execution model (no more TestSuite). 
- Supported by a variety of tools and plug-ins (Eclipse, 
  IDEA, Maven, etc...). 
- Embeds BeanShell for further flexibility. 
- Default JDK functions for runtime and logging 
  (no dependencies). 
- Dependent methods for application server testing. 
TestNG is designed to cover all categories of tests:  
unit, functional, end-to-end, integration, etc...

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p0 -b .sav0
%{_bindir}/find -type f -name "*.jar" | xargs -t %{__rm}

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip deploy javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

pushd maven2-brew

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p org/testng/testng/%{namedversion}/testng-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%{__cp} -p org/testng/testng/%{namedversion}/testng-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)
(cd %{buildroot}%{_javadir} && %{__ln_s} %{name}.jar %{name}-jdk15.jar)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org/testng/testng/%{namedversion}/testng-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

popd

# depmaps
%add_to_maven_depmap org.testng testng %{namedversion} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -pr doc %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -p *.txt %{buildroot}%{_docdir}/%{name}-%{namedversion}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-jdk15.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{namedversion}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Sun Jan 13 2013 Ralph Apel <r.apel@r-apel.de> 0:6.3.1-2
- rebuild to replace damaged package files

* Fri Sep 21 2012 Ralph Apel <r.apel@r-apel.de> 0:6.3.1-1
- 6.3.1

* Thu Sep 22 2011 Ralph Apel <r.apel@r-apel.de> 0:6.1.1-3
- Add testng-jdk15 compat symlink

* Wed Aug 04 2011 David Walluck <dwalluck@redhat.com> 0:6.1.1-2
- remove some unused sources

* Wed May 04 2011 David Walluck <dwalluck@redhat.com> 0:6.1.1-1
- 6.1.1
- remove GCJ support

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 5.8-2
- Auto rebuild for JPackage 6 in centos5 mock

* Sat Aug 01 2009 Ralph Apel <r.apel at r-apel.de> - 0:5.8-1jpp
- 5.8

* Fri Jan 25 2008 Ralph Apel <r.apel at r-apel.de> - 0:5.6-1jpp
- First JPP release
